//!
//! @file scheduler.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͌v敔̒`łB
//!
//! ̧ق͌v敔`ƌv敔ɂĎsׂƊ֐܂݂܂B
//! :
//!   config.hSCHEDULER_TICKFPER`܂B
//!
//! @version 1.12 at90usb128-demo-touchscreen-1_0_0 $Id: scheduler.h,v 1.12 2006/03/08 16:17:03 rletendu Exp $
//!
//! @todo
//! @bug
//!

#ifndef _SCHEDULER_H_
#define _SCHEDULER_H_

/*_____ ݸٰ ____________________________________________________________*/
#ifdef KEIL
#include <intrins.h>
#define Wait_semaphore(a) while(!_testbit_(a))
#else
#define Wait_semaphore(a) while(!(a)) (a) = FALSE
#endif

/*_____ ϸ ________________________________________________________________*/
//! ID̒`BID͓̍Ƃ֎ۂ𐳂邽߂ɗp܂B
//! :TASK_1 | TASK_0ɂđ̍ƂɎۂ𑗂邱Ƃ\łB
//! `͕ʂ̒`ɂĕύX邱Ƃł܂B̓Ǝmail_evt.ḩ
//! ōsׂłB
#define TASK_DUMMY		0x00	// ̒`͕K{łB
#define TASK_0			0x01
#define TASK_1			0x02
#define TASK_2			0x04
#define TASK_3			0x08
#define TASK_4			0x10
#define TASK_5			0x20
#define TASK_6			0x40
#define TASK_7			0x80

// ̒`͕K{łB
#define ALL_TASK		(TASK_0|TASK_1|TASK_2|TASK_3|TASK_4|TASK_5|TASK_6|TASK_7)
//! IDI

//!----- v敔` -----
#define SCHEDULER_CUSTOM	0
#define SCHEDULER_TIMED		1
#define SCHEDULER_TASK		2
#define SCHEDULER_FREE		3

#ifdef Scheduler_time_init
  extern void Scheduler_time_init (void);
#endif

#ifdef Scheduler_task_1_init
  extern void Scheduler_task_1_init (void);
#else
  // SĂɉď]܂Ȃꍇ͈ȉsĂB
  // #define Scheduler_task_1_init scheduler_empty_fct
  #error Scheduler_task_1_initcongif.ḩقŒ`Ȃ΂Ȃ܂B
#endif
#ifdef Scheduler_task_2_init
  extern void Scheduler_task_2_init (void);
#endif
#ifdef Scheduler_task_3_init
  extern void Scheduler_task_3_init (void);
#endif
#ifdef Scheduler_task_4_init
  extern void Scheduler_task_4_init (void);
#endif
#ifdef Scheduler_task_5_init
  extern void Scheduler_task_5_init (void);
#endif
#ifdef Scheduler_task_6_init
  extern void Scheduler_task_6_init (void);
#endif
#ifdef Scheduler_task_7_init
  extern void Scheduler_task_7_init (void);
#endif
#ifdef Scheduler_task_8_init
  extern void Scheduler_task_8_init (void);
#endif
#ifdef Scheduler_task_9_init
  extern void Scheduler_task_9_init (void);
#endif
#ifdef Scheduler_task_10_init
  extern void Scheduler_task_10_init (void);
#endif
#ifdef Scheduler_task_11_init
  extern void Scheduler_task_11_init (void);
#endif

#ifdef Scheduler_task_1
  extern void Scheduler_task_1 (void);
#else
  // SĂɉčƂ]܂Ȃꍇ͈ȉsĂB
  // #define Scheduler_task_1 scheduler_empty_fct
  #error Scheduler_task_1congif.ḩقŒ`Ȃ΂Ȃ܂B
#endif
#ifdef Scheduler_task_2
  extern void Scheduler_task_2 (void);
#endif
#ifdef Scheduler_task_3
  extern void Scheduler_task_3 (void);
#endif
#ifdef Scheduler_task_4
  extern void Scheduler_task_4 (void);
#endif
#ifdef Scheduler_task_5
  extern void Scheduler_task_5 (void);
#endif
#ifdef Scheduler_task_6
  extern void Scheduler_task_6 (void);
#endif
#ifdef Scheduler_task_7
  extern void Scheduler_task_7 (void);
#endif
#ifdef Scheduler_task_8
  extern void Scheduler_task_8 (void);
#endif
#ifdef Scheduler_task_9
  extern void Scheduler_task_9 (void);
#endif
#ifdef Scheduler_task_10
  extern void Scheduler_task_10 (void);
#endif
#ifdef Scheduler_task_11
  extern void Scheduler_task_11 (void);
#endif

/*_____ ` _______________________________________________________________*/
#if SCHEDULER_TYPE != SCHEDULER_FREE
extern bit scheduler_tick_flag;
#endif

#ifdef TOKEN_MODE
extern Uchar token;
#define TOKEN_FREE		0
#endif

/*_____ 錾 _______________________________________________________________*/
void scheduler_init      (void);
void scheduler_tasks     (void);
void scheduler           (void);
void scheduler_empty_fct (void);

#ifndef SCHEDULER_TYPE
  #error config.h fileSCHEDULER_TYPE`Ȃ΂Ȃ܂B
#elif SCHEDULER_TYPE == SCHEDULER_FREE
  #define Scheduler_set_tick_flag()
  #define Scheduler_reset_tick_flag()
#elif SCHEDULER_TYPE == SCHEDULER_TIMED
  #define Scheduler_new_schedule()		Wait_semaphore(scheduler_tick_flag)
  #define Scheduler_set_tick_flag()		(scheduler_tick_flag = TRUE)
  #define Scheduler_reset_tick_flag()	(scheduler_tick_flag = FALSE)
#elif SCHEDULER_TYPE == SCHEDULER_TASK
  #define Scheduler_call_next_task()	Wait_semaphore(scheduler_tick_flag)
  #define Scheduler_set_tick_flag()		(scheduler_tick_flag = TRUE)
  #define Scheduler_reset_tick_flag()	(scheduler_tick_flag = FALSE)
#elif SCHEDULER_TYPE == SCHEDULER_CUSTOM
  #error Scheduler_new_scheduleScheduler_call_next_taskϸۂƊ֐̍\ݒmɂĂB
  #define Scheduler_set_tick_flag()		(scheduler_tick_flag = TRUE)
  #define Scheduler_reset_tick_flag()	(scheduler_tick_flag = FALSE)
#endif

#ifndef Scheduler_call_next_task
  #define Scheduler_call_next_task()
#endif
#ifndef Scheduler_new_schedule
  #define Scheduler_new_schedule()
#endif
#ifndef Scheduler_call_next_init
  #define Scheduler_call_next_init()
#endif

#endif //! _SCHEDULER_H_
