//! @file usb_key.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قUSBKEYp̒ϸۂƒ`܂݂܂B
//!
//! @version 1.6 at90usb128-demo-touchscreen-1_0_0
//!
//! @todo
//! @bug

#ifndef USB_KEY_H
#define USB_KEY_H

//_____ ݸٰ _______________________________________________________________

#include "config.h"

//_____ ϸ ___________________________________________________________________

//! @defgroup USB_KEY_module USBKEY
//! ̕AT90USBkeyp̒ʰ޳ۑw܂݂܂B
//! @image html avrusbkey.gif
//! @{

	//! @defgroup USB_key_leds LEDǗ
	//! USBKEYLEDǗϸ
	//! @{
#define Leds_init()			(DDRD |= 0xF0)
#define Leds_on()			(PORTD |= 0xF0)		// 
#define Leds_off()			(PORTD &= 0x0F)
#define Led0_on()			(PORTD |= 0x10)		// 
#define Led1_on()			(PORTD |= 0x20)		// 
#define Led2_on()			(PORTD |= 0x40)		// 
#define Led3_on()			(PORTD |= 0x80)		// 
#define Led0_off()			(PORTD &= 0xEF)
#define Led1_off()			(PORTD &= 0xDF)
#define Led2_off()			(PORTD &= 0xBF)
#define Led3_off()			(PORTD &= 0x7F)
#define Led0_toggle()		(PIND |= 0x10)
#define Led1_toggle()		(PIND |= 0x20)
#define Led2_toggle()		(PIND |= 0x40)
#define Led3_toggle()		(PIND |= 0x80)
#define Leds_set_val(c)		(Leds_off(),PORTD |= (c<<4)&0xF0)
#define Leds_get_val()		(PORTD>>4)
#define Is_led0_on()		(PIND & 0x10 ? TRUE : FALSE)
	//! @}

	//! @defgroup USB_key_joy ޮèǗ
	//! USBkey̼ޮèǗϸ
	//! @{
#define Joy_init()			(DDRB &= 0x1F, PORTB |= 0xE0, DDRE &= 0xE7, PORTE |= 0x30)
#define Is_joy_up()			((PINB & 0x80) ?  FALSE : TRUE)
#define Is_joy_not_up()		((PINB & 0x80) ?  TRUE  : FALSE)
#define Is_joy_left()		((PINB & 0x40) ?  FALSE : TRUE)
#define Is_joy_not_left()	((PINB & 0x40) ?  TRUE : FALSE)
#define Is_joy_select()		((PINB & 0x20) ?  FALSE : TRUE)
#define Is_joy_not_select()	((PINB & 0x20) ?  TRUE : FALSE)
#define Is_joy_right()		((PINE & 0x10) ?  FALSE : TRUE)
#define Is_joy_not_right()	((PINE & 0x10) ?  TRUE : FALSE)
#define Is_joy_down()		((PINE & 0x20) ?  FALSE : TRUE)
#define Is_joy_not_down()	((PINE & 0x20) ?  TRUE : FALSE)
	//! @}

	//! @defgroup USB_key_HWB HWBtǗ
	//! HWBtPE2ɐڑAʓIȉtƂĂgp邱Ƃł܂B
	//! @{
#define Hwb_button_init()	(DDRE &= 0xFB, PORTE |= 0x04)
#define Is_hwb()			((PINE & 0x04) ?  FALSE : TRUE)
#define Is_not_hwb()		((PINE & 0x04) ?  TRUE : FALSE)
	//! @}

// USBKEY A/Dϊْ`
#define ADC_TEMP_CH			0x00

#ifdef USE_ADC				//!< ̒`config.ḩقŒ`܂B

//! @brief ̊֐USBKEYxقA/DϊsU16l10ޯĂ̌ʂ
//! Ԃ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param	Ȃ
//!
//! @return	U16 ۸ފm퉷xl
//!
U16 Get_adc_temp_val (void);

//! @brief ̊֐USBKEYxقA/DϊsS16l10ޯĂ̌ʂ
//! (ł)xԂ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param	Ȃ
//!
//! @return	S16 ł̉xl
//!
S16 Read_temperature (void);

#endif //USE_ADC

	//! @defgroup USB_key_df USBKEYʰ޳Dataflash`Ԑݒ
	//! USBKEYDataflashp̊ϸ
	//! @{
//! USBKEYɎꂽDataflasȟ`
#ifdef USBKEY_HAS_321_DF
  #define DF_4_MB			// AT90DB321C؂񎎍
#else
  #define DF_8_MB			// AT45DB642D
#endif

#define DF_SELECT_MEM		0
#define DF_UNSELECT_MEM		1

#define DF_NB_MEM			2

#ifndef AVRGCC
  // PORTB_Bit0=1,DDRB_Bit0=0							: SPI]uÍB/SSް͓͂ŁAٱߒRɂ܂B
  // DDRB_Bit1=1										: SCKM̕͏o͂łB
  // DDRB_Bit2=1										: SIM̕͏o͂łB
  // DDRB_Bit3=0										: SOM̕@͓͂łB
  // PORTE_Bit0=1,DDRE_Bit0=1,PORTE_Bit1=1,DDRE_Bit1=1	: CSHighɋ쓮ACS͏o͂łB
  #define Init_df_usb_key()		(PORTB_Bit0=1,DDRB_Bit0=0,DDRB_Bit1=1,DDRB_Bit2=1,\
								  DDRB_Bit3=0,DDRE_Bit0=1,DDRE_Bit1=1,Df_desel_all())
  #define DF_CS0				PORTE_Bit0
  #define DF_CS1				PORTE_Bit1
  #define DF_CS2				DF_CS0
  #define DF_CS3				DF_CS0
  #define Df_select_df(i, val)	(DF_CS##i = val)

  #define Df_desel_all()		(DF_CS0=DF_UNSELECT_MEM,DF_CS1=DF_UNSELECT_MEM)	// /CS Dataflashؐݒ(I)
#else //! AVRGCCp
  #define Init_df_usb_key()		(PORTB|=0x01,DDRB &= 0xFE,DDRB|=0x01,DDRB|=0x04,\
								  DDRB|=0x04,DDRE|=0x01,DDRE|=0x02,Df_desel_all())
  #define DF_CS_PORT			PORTE
  #define DF_CS0				0
  #define DF_CS1				1
  #define DF_CS2				DF_CS0
  #define DF_CS3				DF_CS0

  #define Df_desel_all()		(DF_CS_PORT|=0x03)								// /CS Dataflashؐݒ(I)
#endif

#define df_init_spi()			Init_df_usb_key()
	//! @}
//! @}

#endif // USB_KEY_H
