/*H****************************************************************************
* O: usb_specific_request.h
*------------------------------------------------------------------------------
* 쌠 (c) 2004 Atmel.
*------------------------------------------------------------------------------
* J: at90usb128-demo-touchscreen-1_0_0
* : 1.2
*------------------------------------------------------------------------------
* ړI:
* ̧ق͉pɑΉĂі߂֐܂݂܂B
******************************************************************************/

#ifndef _USB_USER_ENUM_H_
#define _USB_USER_ENUM_H_

/*_____ ݸٰ _____________________________________________________________*/

#include "config.h"

/*_____ ϸ _________________________________________________________________*/

extern code S_usb_device_descriptor usb_dev_desc;
extern code S_usb_user_configuration_descriptor usb_conf_desc;
extern code S_usb_user_configuration_descriptor usb_other_conf_desc;
extern code S_usb_device_qualifier_descriptor usb_qual_desc;
extern code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor;
extern code S_usb_product_string_descriptor usb_user_product_string_descriptor;
extern code S_usb_serial_number usb_user_serial_number;
extern code S_usb_language_id usb_user_language_id;

/*_____ ` ________________________________________________________________*/
Bool usb_user_read_request (U8, U8);
Bool usb_user_get_descriptor (U8, U8);
void usb_user_endpoint_init (U8);
void hid_get_report (void);
void hid_set_report (void);
void usb_hid_get_interface (void);
void usb_hid_set_idle (void);
void hid_get_hid_descriptor (void);

typedef struct								//!< USB HID񍐋LqqڐG
{
	U8 report[58];
} S_usb_hid_report_descriptor_touchscreen;

typedef struct								//!< USB HID񍐋Lqqް
{
	U8 report[0x3B];
} S_usb_hid_report_descriptor_kbd;

#endif
